//==============================================================
// IR wave viewer 1.00    (STPP.01)
//     for PSP CFW3.71 M33 + 1.50 Kernel addon (PSP-1000p)
// STEAR 2008
//--------------------------------------------------------------
// IrDA|[g𗘗pĐԊOȐo͔g`ώ@Ă݂AvB
// IrDÃ{[[gύX邽߃n[h𒼐ڂĂ̂ŃJ[l[h
// œĂ܂B

#include <pspkernel.h>
#include <psppower.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <pspsystimer.h>

#include "zenkaku.h"
#include "serialport.h" 

//----- }N -----

#define SCRBUF0		(char*)(0)

/*LbVȂVRAM  VRAM[y][x]ƂăANZX*/
#define VRAM		((long(*)[BUF_WIDTH])(((char*)0x4000000)+0x40000000))

//----- 萔ݒ -----

#define IRBUFSIZE	5*40000										// IRMobt@TCY (5bԕ)
#define CORLINE		0x80C080									// r
#define CORTITLE	0x507050									// ^Cgwi
#define CORROLLBAR	0x90FF90									// XN[o[
#define CORLOW		0x204000									// LOW
#define CORHI		0x8080FF									// HI
#define CORREC		0x906090									// M

//----- vg^Cv錾 -----

//- VXe֘A -

int		SetupCallbacks(void);
int		callbackThread(SceSize args, void *argp);
int		exitCallback(int arg1, int arg2, void *common);
int		power_callback(int unknown, int pwrflags, void *common);

//- ̑ -

void	WaveDraw(long DrawPos,int Range);
void	RollBar(long pos,int range);
void	RangeDraw(int range);
void	PacketDraw(int range);
void	WaveLog(void);
void	HLine(int x,int y,int wx,long cor);
void	VLine(int x,int y,int wy,long cor);
void	BoxClr(int x,int y,int xw,int yw);
void	ValDraw3(int x,int y,int va);
void	SetIrBPS(void);
int		timer_handler(void);

//------ O[oϐ -----

static volatile unsigned char gIrWave[IRBUFSIZE];				// IRMobt@(Oobt@)
static unsigned int __attribute__((aligned(16))) gList[18];
static volatile int	gExitRequest = 0,
					gResumeFlag = 0,
					gBlankTime = 200,							// t[Ԋu
					gIrStartFlag;								// L^Jn^C~Op
static volatile long gIWPosT,gIWSize;							// IRMobt@̃|C^
static volatile long gAnchor1 = 0,gAnchor2 = 0;					// AJ[|Cg
SceSysTimerId gTimer;

//------ s[hw -----

PSP_MODULE_INFO("IRVIEW", 0x1000, 1, 0);						// J[l[h
PSP_MAIN_THREAD_ATTR(0);
PSP_MAIN_THREAD_STACK_SIZE_KB(32);								// ꂪƃTXyhoȂH


//==============================================================
// main
//--------------------------------------------------------------

int	main(int argc,char **argv)
{
	int				j,fd,range,padPush,mode;
	long			i,pos,sum,count;
	SceCtrlData		pad;

	SetupCallbacks();

	sceGuInit();
	sceGuStart(GU_DIRECT, gList);
	sceGuDrawBuffer(GU_PSM_8888, SCRBUF0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, SCRBUF0, BUF_WIDTH);
	sceGuFinish();
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_DIGITAL);

	fd = sceIoOpen("irda0:", PSP_O_RDWR, 0);					// IrDAI[v
	SetIrBPS();													// BPS1500000֕ύX
	gTimer = sceSTimerAlloc();
	sceSTimerStartCount(gTimer);
	sceSTimerSetHandler(gTimer, 4194303/4000, timer_handler, 0);	//0.025[ms]PʂIRTvO

	mh_print(  0, FONTHEIGHT*0, "ԊOf[^M", 0x8080FF);
	mh_print(130, FONTHEIGHT*0, "~:ꎞ~ :ĊJ :ݼޕύX LR:߰ޑ :ڰъԊu", 0x707070);
	mh_print(400, FONTHEIGHT*1, "(c)STEAR 2008", 0x707070);

	HLine(  0, 15,70,CORLINE);									// Mf[^^Cg
	for (j=0; j<14 ;j++)										// Mf[^^Cg
		HLine(0, 16+j,70,CORTITLE);
	VLine(  0, 15,15,CORLINE);									// Mf[^^Cg
	VLine( 70, 15,15,CORLINE);									// Mf[^^Cg
	HLine(  0, 30,SCR_WIDTH,CORLINE);							// Mf[^XN[o[
	VLine(  0, 31,7,CORLINE);									// Mf[^XN[o[
	VLine(479, 31,7,CORLINE);									// Mf[^XN[o[
	HLine(  0, 38,SCR_WIDTH,CORLINE);							// Mf[^XN[o[
	VLine(  0, 37,33,CORLINE);									// Mf[^
	VLine(479, 37,33,CORLINE);									// Mf[^
	HLine(  0, 89,70,CORLINE);									// t[^Cg
	for (j=0; j<14 ;j++)
		HLine(0, 90+j,70,CORTITLE);								// t[^Cg
	VLine(  0,89,15,CORLINE);									// t[^Cgc
	VLine( 70,89,15,CORLINE);									// t[^Cgc
	HLine(  0,104,SCR_WIDTH,CORLINE);							// t[
	VLine(  0,105,13,CORLINE);									// t[c
	VLine(479,105,13,CORLINE);									// t[c
	HLine(  0,118,SCR_WIDTH,CORLINE);							// t[
	HLine(  0,122,70,CORLINE);									// O^Cg
	for (j=0; j<14 ;j++)
		HLine(0,123+j,70,CORTITLE);								// O^Cg
	VLine(  0,122,15,CORLINE);									// O^Cgc
	VLine( 70,122,15,CORLINE);									// O^Cgc
	HLine(  0,137,SCR_WIDTH,CORLINE);							// O̐
	VLine(  0,138,133,CORLINE);									// Oc
	VLine(479,138,133,CORLINE);									// Oc
	HLine(  0,271,SCR_WIDTH,CORLINE);							// O̐

	mh_print(  3, 17, "Mf[^", 0xFFFFFF);
	mh_print( 90, 17, "W:", 0xFFFFFF);
	mh_print(170, 17, "MW:", 0xFFFFFF);
	mh_print(  3, 91, "t[", 0xFFFFFF);
	mh_print( 90, 91, "t[Ԋu:000ms", 0xFFFFFF);
	ValDraw3( 90+ FONTWIDTH*13, 91, gBlankTime/40);				// t[Ԋu\
	mh_print(  3, 124, "Log", 0xFFFFFF);

	range = 1;
	mode = 0;													// 0:M 1:g`\
	padPush = 0;												// z^Ă邩 0:No 1:Yes
	gIrStartFlag = 0;											// 0ȂIRHI͂܂ŃTvOsȂ
	gIWPosT = 0;												// IrWave擪ʒu
	gIWSize = 0;												// IrWaveTCY
	pos = 0;													// Mf[^\ʒu
	while(!gExitRequest){
		if (gResumeFlag){										// W[ꂽ
			gResumeFlag = 0;
			SetIrBPS();											// BPS1500000֕ύX
		}
		sceCtrlReadBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_TRIANGLE && padPush == 0){
			gBlankTime += 40;									// t[ԊuԐ؂ւ
			if (gBlankTime > 800) gBlankTime = 40;
			ValDraw3(90+ FONTWIDTH*13, 91, gBlankTime/40);		// t[Ԋu\
			if (mode) PacketDraw(range);						// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE && padPush == 0){
			BoxClr(0,0,FONTWIDTH*18,FONTHEIGHT);
			mh_print(0, FONTHEIGHT*0,"ԊOf[^M", CORHI);
			BoxClr(170+ FONTWIDTH*9 ,17, FONTWIDTH*3 , FONTHEIGHT);
			sceSTimerStartCount(gTimer);						// IRTvOJn
			mode = 0;
			padPush = 1;
			pos = 0;
		}
		if (pad.Buttons & PSP_CTRL_CROSS && padPush == 0){
			BoxClr(0,0,FONTWIDTH*18,FONTHEIGHT);
			mh_print(0, FONTHEIGHT*0, "g`\\", 0xFF8080);
			sceSTimerStopCount(gTimer);							// IRTvO~
			mode = 1;
			padPush = 1;
			pos = 0;
			sum = 0;
			count = 1;
			for (i=0; i<IRBUFSIZE ;i++)							// MW̏Wv
				if (gIrWave[i] != 0){
					sum += gIrWave[i];
					count++;
				}
			sum = sum * 100 / count;
			ValDraw3(170+ FONTWIDTH*9, 17, sum);
		}
		if (pad.Buttons & PSP_CTRL_UP && padPush == 0){
			range++;
			if (range > 99) range = 99;
			PacketDraw(range);									// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_DOWN && padPush == 0){
			range--;
			if (range < 1) range = 1;
			PacketDraw(range);									// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_LEFT){
			pos += 1 * range;
			if (pos > gIWSize) pos = gIWSize;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT){
			pos -= 1 * range;
			if (pos < 0) pos = 0;
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER && padPush == 0){
			pos += 400 * range;
			if (pos > gIWSize) pos = gIWSize;
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER && padPush == 0){
			pos -= 400 * range;
			if (pos < 0) pos = 0;
			padPush = 1;
		}
		if (!(pad.Buttons & 0x0FFF0))							// {^ĂȂ
			padPush = 0;

		RollBar(pos,range);										// XN[o[
		RangeDraw(range);										// Wƃ[[̕\
		WaveDraw(pos,range);									// ԊOg`
		if (!mode){
			PacketDraw(range);									// t[̓\
			WaveLog();											// Mf[^O
		}
		sceDisplayWaitVblankStart();
	}

	sceSTimerFree(gTimer);
	sceIoClose(fd);
	sceGuTerm();
	sceKernelExitGame();
	sceKernelSleepThread();
	return 0;
}

//==============================================================
// ԊOg`̍
//--------------------------------------------------------------

void WaveDraw(long DrawPos,int Range)
{
	long pos,poss,len,cor;
	int i,x,sum,cnt;

	pos = gIWPosT - 1;
	len = gIWSize;
	if (DrawPos > len) DrawPos = len;
	pos -= DrawPos;
	if (pos < 0) pos += IRBUFSIZE;
	len -= DrawPos;
	x = SCR_WIDTH -1;
	while(x>1){
		if (len <= 0){
			BoxClr(1,40,x-1,30);								// ]vȃS~͏
			break;
		}
		sum = 0;
		cnt = 0;
		poss = pos;
		for (i=0; i<Range ;i++){								// Range͈̔͂̃f[^̕ς𒲂ׂ
			sum += gIrWave[poss];
			if (gIrWave[poss]) cnt++;
			poss--;
			if (poss < 0) poss += IRBUFSIZE;
		}
		if (cnt)
			sum = (sum+cnt-1) / cnt;							// _ȉ؂グ
		else
			sum = 0;
		for (i=0; i<16 ;i++)									// M
			VRAM[55-i][x-1] = (sum==0 || i>sum*3) ? CORLOW : CORREC;
		cor = (sum==0) ? CORLOW : CORHI;
		for (i=0; i<13 ;i++)									// Mg`
			VRAM[57+i][x-1] = cor;
		pos -= Range;
		if (pos < 0) pos += IRBUFSIZE;
		len -= Range;
		x--;
	}
}

//==============================================================
// XN[o[̕\
//--------------------------------------------------------------

void RollBar(long pos,int range)
{
	int i;
	long len,p;
	static long lenBuf = 0,pBuf = 0;

	if (gIWSize == 0)
		p = 0;
	else
		p = pos * (SCR_WIDTH -2) / gIWSize;
	if (gIWSize == 0)
		len = SCR_WIDTH -2;
	else
		len = (SCR_WIDTH -1) * SCR_WIDTH * range / gIWSize;
	if (len > (SCR_WIDTH -2)) len = SCR_WIDTH -2;				// ʂ͂ݏoꍇ̕␳
	if (p + len > (SCR_WIDTH -2)) p = SCR_WIDTH -2 - len;		// ʂ͂ݏoꍇ̕␳

	if (lenBuf == len && pBuf == p) return;						// OƓȂ悵Ȃ
	lenBuf = len;
	pBuf = p;

	for (i=0; i<7 ;i++){										// XN[o[
		HLine(1,31+i,SCR_WIDTH-2,CORTITLE);						// x
		HLine(SCR_WIDTH-1 -p -len,31+i,len,CORROLLBAR);			// V㏑
	}
}

//==============================================================
// W̕\ƃXP[̕\
//--------------------------------------------------------------

void RangeDraw(int range)
{
	static int bak = 0;
	int a,i,x;

	if (bak == range) return;									// Kv̖Ƃ͏Ȃ
	bak = range;

	ValDraw3(90+FONTWIDTH*7,17,range);							// W

	BoxClr(0,70,480,FONTHEIGHT+3);
	for (i=0; i<SCR_WIDTH ;i++){								// ڈ
		VRAM[70][i] = CORLINE;
		if (i %  4 == 0) VRAM[70 +1][i] = 0xFFFFFF;
		if (i % 20 == 8) VRAM[70 +2][i] = 0xFFFFFF;
		if (i % 40 == 8) VRAM[70 +3][i] = 0xFFFFFF;
	}
	x = 8;
	a = 0;
	while(x<SCR_WIDTH){											// XP[̒l
		ValDraw3(x-8,70 +5,a);
		x += 40;
		a += range;
	}
	mh_print(465,70 + 5,"ms", 0xFFFFFF);
}

//==============================================================
// t[̓\
//--------------------------------------------------------------
// t[̓́uԊO͂̃TvOvłĂ܂B
// obt@̃f[^ɍ悵Ă邽߁Aobt@NAƕ\
// ܂B

void PacketDraw(int range)
{
	int  x,y;
	long pos;

	pos = gAnchor2;
	for (x=1; x<SCR_WIDTH-1 ;x++){
		for (y=0; y<13 ;y++)
			VRAM[105+y][x] = (gIrWave[pos] == 0) ? CORLOW : CORHI;
		pos += range;
		if (pos >= IRBUFSIZE) pos -= IRBUFSIZE;
	}
}

//==============================================================
// Mf[^̃TlC
//--------------------------------------------------------------
// Mobt@̓e1/3ɏkĉʂɕ\Ă܂B
// ԕׂ鏈B

void WaveLog(void)
{
	const long cor[] = {CORLOW,0x3030B0,0x7070E0,0x9090FF,0xB0B0FF,0xE0E0FF};
	      long i,j,pos;

	pos = gIWPosT;
	for (i=SCR_HEIGHT-1; i>138 ;i--)
		for (j=SCR_WIDTH-1; j>1 ;j--){
			VRAM[i-1][j-1] = cor[gIrWave[pos]];
			pos -=3;
			if (pos < 0) pos += IRBUFSIZE;
		}
}

//==============================================================
// ̍
//--------------------------------------------------------------

void HLine(int x,int y,int wx,long cor)
{
	int i;

	for (i=0; i<wx ;i++)
		VRAM[y][x+i] = cor;
}

//==============================================================
// c̍
//--------------------------------------------------------------

void VLine(int x,int y,int wy,long cor)
{
	int i;

	for (i=0; i<wy ;i++)
		VRAM[y+i][x] = cor;
}

//==============================================================
// ẅ̃NA
//--------------------------------------------------------------

void BoxClr(int x,int y,int wx,int wy)
{
	int i;

	for (i=0; i<wy ;i++)
		HLine(x,y + i,wx,0);
}

//==============================================================
// wʒuɐl`(3)
//--------------------------------------------------------------
// 3ȏ̐lw肳ꂽꍇ͉3\܂B
// wi͏܂B
// ȈՓIȎłB

void ValDraw3(int x,int y,int va)
{
	char s[4];

	s[0] = '0' + ((va / 100) % 10);
	s[1] = '0' + ((va /  10) % 10);
	s[2] = '0' + ((va /   1) % 10);
	s[3] = 0;
	BoxClr(x,y,FONTWIDTH*3,FONTHEIGHT);
	mh_print(x,y, s, 0xFFFFFF);
}

//==============================================================
// ԊO͂̃TvO
//--------------------------------------------------------------
// 0.025[ms]IrDA|[gǂ݁Af[^ΐԊOHÍAf[^
// LOW͂ƔfAʂgIrWave[]ɋL^܂B
// ̃TvOƒIHI͂r؂Ă܂̂ŕԏ
// ܂B
// gIrWave[]̓e
//     0 : LOW
//     1 : ԂꂽHI
//     2 : HI (M1)
//     3 : HI (M2)
//     4 : HI (M3)
//     5 : HI (M4ȏ)
// ԂHI͎̕ώM𒲂ׂΐԊOgg𐄑łƎvǁA
// ǂ낤H
// ŐṼf[^gIWPosT-1̈ʒuɂAɌgIWSizef[^
// ܂B(0Ȃf[^)
// Oobt@Ȃ̂gIWSizeIRBUFSIZEɒBĂ܂ƈԌÂ
// f[^㏑Ă܂B
//
// gIrStartFlag0̎LOWf[^͓ǂݔ΂܂B܂HI͑҂ԂłB
//
// 莞Ԉȏ̖MԂĂHI͂AMt[
// JnʒuƔfAJ[ݒuĂ܂B
// ÕAJ[ʒu獡̃AJ[ʒu܂łMt[PɂȂł
// At[̕ԂK؂ɐݒ肵ȂƂƃt[ołȂ̂
// ӂKvBit[̋󔒎Ԃ͒At[ԊԊu͒Zj
// wK^Rɉpꍇ͂̕ӂǂ邩肩Bi̗l
// gp҂ɐݒ肵Ă炤̂mHj

int	timer_handler(void)
{
	static unsigned char	data[20];
	static int				len,buf[3];
	static long				pos,ancCnt = 0;

	len = serialport_read(&psprc_serialport, data, 20,1);
	if (len) gIrStartFlag = 1;									// HI͂L^Jn
	if (gIrStartFlag){
		if (len>5) len = 5;
		buf[0] = buf[1];
		buf[1] = buf[2];
		buf[2] = len;
		if (len) len++;
		if (buf[0]!=0 && buf[1]==0 && buf[2]!=0 && gIWSize>2){	// HI͕ (HI,LOW,HI̕тɂȂLOWHIɒu)
			pos = gIWPosT - 1;
			if (pos < 0) pos += IRBUFSIZE;						// Oobt@̋E
			gIrWave[pos] = 1;
		}
		gIrWave[gIWPosT] = len;

		pos = gIWPosT - 1;										// t[̊Jnʒu
		if (pos < 0) pos += IRBUFSIZE;
		if (gIrWave[gIWPosT] != 0){
			if (gIrWave[pos] == 0){								// LOWHI
				if (ancCnt > gBlankTime){						// LOW莞Ԉȏ㑱Ă
					gAnchor2 = gAnchor1;
					gAnchor1 = gIWPosT;							// AJ[Zbg
				}
				ancCnt = 0;
			}
		}else
			ancCnt++;											// LOW̎ԂJEg

		gIWPosT++;
		if (gIWPosT >= IRBUFSIZE) gIWPosT -= IRBUFSIZE;
		gIWSize++;
		if (gIWSize >= IRBUFSIZE) gIWSize = IRBUFSIZE;
	}
	return -1;
}

//==============================================================
// IrDA|[gBPSύX
//--------------------------------------------------------------
// IrDA|[g͂OPEN9600bpsɐݒ肳Ă̂Aꂾ
// \SȂ̂Ő퓮삷͈͓ŎvグĂ܂B
// XԊORIrDA̕ϒɂ͌݊̂IrDA̋KiȂĖ
// łB
// ܂ŏグƂȂƐԊOR̐ԊOϒg܂Ōoł
// C܂ڂ͌؂Ă܂B

void SetIrBPS(void)
{
	serialport_setspeed(&psprc_serialport,1500000);				// BPS1500000֕ύX
}

//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;
	return 0;
}

//==============================================================
// Power callback
//--------------------------------------------------------------
// d֘ÃCxg

int power_callback(int unknown, int pwrflags, void *common)
{
	if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE){				// W[
		gResumeFlag = 1;
	}

    sceDisplayWaitVblankStart();

	return 0;
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
    cbid = sceKernelCreateCallback("Power Callback", power_callback, NULL);
    scePowerRegisterCallback(0, cbid);

	sceKernelSleepThreadCB();

	return 0;
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, THREAD_ATTR_USER, 0);
	if(thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}
